<?php
// Copyright (C) 2008 - 2011 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

function getdvdinfo($dvdid) { 
	$dvdidurl = substr($dvdid,0,8).substr($dvdid,9,8);
	$curl_connection = curl_init ("http://api.vortexbox.org/dvdinfo.php?dvdid=".$dvdidurl) ;
	curl_setopt ($curl_connection, CURLOPT_RETURNTRANSFER, 1) ;
	$dvdtitle = curl_exec ($curl_connection) ;
	curl_close ($curl_connection) ;
	return $dvdtitle;
}

function putdvdinfo($dvdid,$title,$disc_title) { 
	$post_data['dvdid'] = $dvdid;
	$post_data['title'] = $title;
	$post_data['disc_title'] = $disc_title;
	foreach ( $post_data as $key => $value) {
	  $post_items[] = $key . '=' . $value;
	}
	$post_string = implode ('&', $post_items);
	$curl_connection = curl_init('http://api.vortexbox.org/putdvdinfo.php');	
	curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($curl_connection, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt($curl_connection, CURLOPT_POSTFIELDS, $post_string);
	$dvdtitle = curl_exec($curl_connection);
	curl_close($curl_connection);
	return $dvdtitle;
}

$dvdtitle = "0";
$dvdid = $argv[1];
$movie_title_dvd  = $argv[2];
// get the DVD name from vortexbox.org

$dvdtitle = getdvdinfo($dvdid); 

if ($dvdtitle == "0") {
  $post_data['q'] = $dvdid;
  $post_data['action'] = 'submit';
  foreach ( $post_data as $key => $value) {
	$post_items[] = $key . '=' . $value;
  }
  $post_string = implode ('&', $post_items);
  $curl_connection = curl_init('http://www.mcedvd.com/index.php?page=search');
  curl_setopt($curl_connection, CURLOPT_CONNECTTIMEOUT, 30);
  curl_setopt($curl_connection, CURLOPT_USERAGENT, 
	  "Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.13) Gecko/20101203 Firefox/3.6.13");
  curl_setopt($curl_connection, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($curl_connection, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($curl_connection, CURLOPT_FOLLOWLOCATION, 1);
  curl_setopt($curl_connection, CURLOPT_POSTFIELDS, $post_string);
  $result = curl_exec($curl_connection);
  curl_close($curl_connection);
  $regexp = "><li><a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>(.*)<\/a>";
  if(preg_match_all("/$regexp/siU", $result, $matches)) { 
	$x = split("\[",$matches[3][0]);
	$dvdtitle = preg_replace("/&/", "and", $x[0]);
	$dvdtitle = preg_replace("/\//", " - ", $dvdtitle);
	$dvdtitle = str_replace("'", "", $dvdtitle);
	$dvdtitle = str_replace(":", "", $dvdtitle);
	$dvdtitle = str_replace("?", "", $dvdtitle);
	$dvdtitle = putdvdinfo($dvdid,trim($dvdtitle),$movie_title_dvd);
  } else {
	$dvdtitle = putdvdinfo($dvdid,0,$movie_title_dvd);
  }
}

echo $dvdtitle;

?>
