<?php
// Copyright (C) 2008 - 2011 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

error_reporting(E_ERROR);

$configfile = "/var/www/html/config/playergui.cfg";
$configall = file_get_contents($configfile);
$config = unserialize($configall); 

$vbplayer="";
$vbplayerfile = fopen("/etc/vortexbox-player/mac_list.conf",'w');
$x=0;
foreach ($config as $devarray) {
  if (isset($devarray['NAME'])) {
    $mpdfile = fopen("/etc/vortexbox-player/mpd".$x.".conf",'w');

    $configcontent="# Created by Configure VortexBox Player on ".date('F j, Y, g:i a')."\n";
	$configcontent.="# If you edit this file it will be over written the next time you make\n";
	$configcontent.="# changes in the Configure VortexBox Player GUI.\n";
	$configcontent.="#"."\n";
    if ($x == 0) {
      $configcontent.='music_directory  "/storage/music/flac"'."\n";
      $configcontent.='playlist_directory  "/var/lib/mpd/playlists"'."\n";
      $configcontent.='db_file  "/var/lib/mpd/database"'."\n";
      $configcontent.='log_file  "/var/log/mpd.log"'."\n";
      $configcontent.='pid_file  "/var/lib/mpd/pid"'."\n";
      $configcontent.='state_file  "/var/lib/mpd/state"'."\n";
      $configcontent.='sticker_file  "/var/lib/mpd/sticker.sql"'."\n";
    }
	$configcontent.='port  "'.(6600 + $x).'"'."\n";
	$configcontent.='zeroconf_enabled  "yes"'."\n";
	$configcontent.='zeroconf_name  "'.$devarray['NAME'].'"'."\n";
	$configcontent.="\n";
	if (strtoupper($devarray['DEVICENAME']) != "DEFAULT") {
      $configcontent.='audio_output {'."\n";
      $configcontent.='	type		"alsa"'."\n";
      $configcontent.='	name		"'.$devarray['NAME'].'"'."\n";
      $configcontent.='	device		"'.$devarray['DEVICENAME'].'"'."\n";
      if ($devarray['softvol_ischecked'] == "softvol") { $configcontent.='	mixer_type	"software"'."\n";}
      $configcontent.='}'."\n";
    }
    fwrite($mpdfile,$configcontent);
    fclose($mpdfile);
	$vbplayer.=$devarray['MAC']."\n";
  }
  $x++;
}

fwrite($vbplayerfile,$vbplayer);
fclose($vbplayerfile);

// we created the configs now restart vortexbox-player
exec("/etc/init.d/vortexbox-player stop");
sleep(2);
exec("/etc/init.d/vortexbox-player start");
sleep(4);

// now rename players
$x=0;
foreach ($config as $devarray) {
 $fp=pfsockopen("127.0.0.1",9090);

 if (isset($devarray['NAME'])) {
   fputs($fp,strtolower($devarray['MAC'])." name ".rawurlencode($devarray['NAME'])."\r");
   sleep(1);
   $output=fread($fp,128);
   $stat=socket_get_status($fp);
   if ($stat["unread_bytes"] > 0) {
        $output.=fread($fp, $stat["unread_bytes"]);
   }
   echo urldecode($output)."\n";
 }
 fclose($fp);
}
 
?>
