#!/usr/bin/php
<?php
// Copyright (C) 2008 - 2011 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

$server_name="http://api.vortexbox.org/myvb.php";

// Determine MAC address, NIC, and IP address - check for eth0, eth1, and wlan0.

$InterfacesToCheck = array();
exec("ifconfig | grep -E '(eth|wlan|br)' | awk '{print $1}'",$InterfacesToCheck,$ret);
sort($InterfacesToCheck);

foreach ($InterfacesToCheck as $Interface) {
  $InterfaceIPaddress = exec('ifconfig '.$Interface.' | grep "inet addr" | sed "s/^ *inet addr://" | cut -d" " -f1');
  if ($InterfaceIPaddress) {
    $nic = "$Interface";
    $ipaddress = $InterfaceIPaddress;
	break;
  }
}

if (file_exists('/etc/vortexbox/vortexbox-vbid')) {
print "Found vortexbox-vbid.\n";
}
else
{
print "Didn't find vortexbox-vbid, we must create one.\n";
$dump = system('/sbin/ifconfig | grep --max-count=1 HWaddr');
preg_match('/[A-F0-9]{2}:[A-F0-9]{2}:[A-F0-9]{2}:[A-F0-9]{2}:[A-F0-9]{2}:[A-F0-9]{2}/i', $dump, $mac);
$mac_address = $mac[0];
//encrypting mac address
$vbid = MD5(date(DATE_RFC822).$mac_address);
system("echo ".$vbid." > /etc/vortexbox/vortexbox-vbid");
}

$SYSNAME = "vortexbox";
$smbfile = "/etc/samba/smb.conf";

$lines = file($smbfile);
$smblines = array();
foreach ($lines as $line_num=>$line) {
		if ( ! preg_match("/#.*/", $line) ) {
		# Contains non-whitespace?
		if ( preg_match("/\S/", $line) ) {
		list( $key, $value ) = explode( "=", trim( $line ), 2);
		$smblines[trim($key)] = trim($value);
		}
	  }
}
$vbname = strtolower($smblines['netbios name']);

$vbid = system('cat /etc/vortexbox/vortexbox-vbid');
$version = system('cat /etc/vortexbox/vortexbox-version');
$vendor = system('cat /etc/vortexbox/vortexbox-vendor');

//check if api.vortexbox.org is up

$response = system("/usr/bin/curl -s http://api.vortexbox.org/status.php");
if($response =="up") {
	$wgetstring ="/usr/bin/curl -s ";
	$wgetstring.=$server_name;
	$wgetstring.="?id=".$vbid;
	$wgetstring.="\&v=".$version;
	$wgetstring.="\&vn=".$vendor;
	$wgetstring.="\&vbip=".$ipaddress;
	$wgetstring.="\&vbname=".$vbname;
	system($wgetstring);
}

?>
