#!/bin/sh
# Copyright (C) 2008 - 2010 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}

echo "" >> /var/log/vbupgrade.log
echolog "Installing Sonos web interface (This can take a long time...)" >> /var/log/vbupgrade.log

yum clean all
rm -rf /var/cache/yum/*
rm -rf /var/lib/yum/yumdb/*
yum -y install sonosweb --skip-broken >> /var/log/vbupgrade.log
touch /etc/vortexbox/packages/sonosweb

echolog "Sonos web interface installed." >> /var/log/vbupgrade.log
echo "" >> /var/log/vbupgrade.log
echo "<b><font color='red'>NOTE: </font>#########################################################</b>" >> /var/log/vbupgrade.log
echo "To complete the installation of the Sonos web interface you must go" >> /var/log/vbupgrade.log
echo "to the <b>Network Configuration</b> page and check off Enable Sonos share." >> /var/log/vbupgrade.log
echo "<b>###############################################################</b>" >> /var/log/vbupgrade.log